import java.io.*;
import java.util.*;

public class subsegment_ma_java {
    String fileName = "";

    public void solve() throws IOException {
        int n = nextInt();
        long c = nextLong();
        char[] s = nextToken().toCharArray();
        int mx = 0;
        long a = 0, b = 0, ab = 0;
        int j = 0;

        for (int i = 0; i < n; i++) {
            while (j < n && ab <= c) {
                mx = Math.max(mx, j - i);
                if (s[j] == 'a') {
                    a++;
                } else if (s[j] == 'b') {
                    b++;
                    ab += a;
                }
                j++;
            }

            if (ab <= c) {
                mx = Math.max(mx, j - i);
            }

            if (s[i] == 'b') {
                b--;
            } else if (s[i] == 'a') {
                ab -= b;
                a--;
            }
        }

        out.println(mx);
    }

    public void run() {
        try {
            if (fileName.equals("")) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else if (fileName.equals("txt")) {
                br = new BufferedReader(new FileReader("input.txt"));
                out = new PrintWriter("output.txt");
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new subsegment_ma_java().run();
    }

}