#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MOD = 998244353;

int mpow(int a, int b) {
	int ret = 1;
	while (b) {
		if (b & 1) {
			ret = (ll) ret * a % MOD;
		}
		a = (ll) a * a % MOD;
		b /= 2;
	}
	return ret;
}

typedef unsigned long long ull;
typedef unsigned int uint;

int prod(int a, int b) {
    ull x = (ull) a * b;
    uint xh = x >> 32, xl = x, q, r;
#ifdef __GNUC__
    asm(
        "divl %4; \n\t"
        : "=a" (q), "=d" (r)
        : "d" (xh), "a" (xl), "r" (MOD)
    );
#else
    __asm {
        mov edx, dword ptr[xh];
        mov eax, dword ptr[xl];
        div dword ptr[MOD];
        mov dword ptr[q], eax;
        mov dword ptr[r], edx;
    };
#endif
    return r;
}

const int bp = 21;
const int sz = 1 << bp;
int arra[sz], arrb[sz];
int roots[sz];
int perm[sz];

void dft(int arr[]) {
	for (int i = 0; i < sz; ++i) {
		if (i < perm[i]) {
			swap(arr[i], arr[perm[i]]);
		}
	}
	for (int l = 1; l < sz; l *= 2) {
		for (int i = 0; i < sz; i += l * 2) {
			for (int j = 0; j < l; ++j) {
				auto tmp1 = arr[i + j];
				auto tmp2 = prod(arr[i + l + j], roots[sz / l / 2 * j]);
				arr[i + j] = tmp1 + tmp2 >= MOD ? tmp1 + tmp2 - MOD : tmp1 + tmp2;
				arr[i + l + j] = tmp1 - tmp2 < 0 ? tmp1 - tmp2 + MOD : tmp1 - tmp2;
			}
		}
	}
}

vector<int> mult(vector<int> a, vector<int> b) {
	for (int i = 0; i < szof(a); ++i) {
		arra[i] = a[i];
	}
	for (int i = 0; i < szof(b); ++i) {
		arrb[i] = b[i];
	}
	dft(arra);
	dft(arrb);
	for (int i = 0; i < sz; ++i) {
		arra[i] = prod(arra[i], arrb[i]);
	}
	dft(arra);
	reverse(arra + 1, arra + sz);
	vector<int> ret;
	int invsz = mpow(sz, MOD - 2);
	for (int i = 0; i < sz; ++i) {
		if (i < szof(a) + szof(b) - 1) {
			ret.push_back(prod(arra[i], invsz));
		}
	}
	return ret;
}

void solve() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	int m, a, b;
	cin >> m >> a >> b;
	vector<int> va;
	for (int i = 0; i < n; ++i) {
		va.push_back(s[i] - '0');
	}
	vector<int> vb;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < a; ++j) {
			vb.push_back(1);
		}
		for (int j = 0; j < b; ++j) {
			vb.push_back(0);
		}
	}
	/*
	for (int num : va) {
		cerr << num << " ";
	}
	cerr << endl;
	for (int num : vb) {
		cerr << num << " ";
	}
	cerr << endl;
	*/
	reverse(vb.begin(), vb.end());
	auto res = mult(va, vb);
	/*
	for (int num : res) {
		cerr << num << " ";
	}
	cerr << endl;
	*/
	int ans = 0;
	for (int i = 0; i <= n - m * (a + b); ++i) {
		if (res[i + m * (a + b) - 1] == a * m) {
			++ans;
		}
	}
	cout << ans << "\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int rt = 421;
	/*
	for (int i = 2; ; ++i) {
		if (mpow(i, 1 << 21) == 1 && mpow(i, 1 << 20) != 1) {
			rt = i;
			break;
		}
	}
	cerr << rt << endl;
	*/
	assert(mpow(rt, 1 << 21) == 1 && mpow(rt, 1 << 20) != 1);
	roots[0] = 1;
	for (int i = 1; i < sz; ++i) {
		roots[i] = (ll) roots[i - 1] * rt % MOD;
		//assert(roots[i] != 1);
	}
	for (int i = 1; i < sz; ++i) {
		perm[i] = (perm[i >> 1] >> 1) | ((i & 1) << (bp - 1));
	}

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}